︠eade2dcc-4ede-4205-828d-7a112634055f︠
def gauss_sums(n):
    p=next_prime(n-1)
    a=primitive_root(p)
    b=1
    powers=[]
    for t in range(1,p):
     b=(b*a) % p 
     powers.append(b)
    zeta_p=exp(2*pi*I/p).n()
    zeta_p1=exp(2*pi*I/(p-1)).n()
    p_roots=[zeta_p^t for t in range(0,p)]
    p1_roots=[zeta_p1^t for t in range(0,p-1)]
    gauss=[]
    for t in range(1,p-1):
        gsum=sum(p1_roots[(t*u)%(p-1)]*p_roots[powers[u]] for u in range(0,p-1))
        gauss.append(gsum)
    return gauss
︡ddcbbeda-e896-452d-8349-797b95e18e7b︡︡
︠e063c5d1-4087-4130-94be-e93c38974c82︠
# plots all normalized gauss sums over Fp, Fp=next_prime(n)
def plot_gauss_sums(n):
    p=next_prime(n-1).n()
    gauss=gauss_sums(n)
    points=[i/sqrt(p) for i in gauss]
    P=circle((0,0),1,aspect_ratio=1,axes=false)
    P+=point(i for i in points)
    return P
︡14f70c26-8dd4-45e7-b5e0-a1308b2ca2b3︡︡
︠14075342-d1b4-4843-b1eb-46fc08732fbc︠
def vert_legendre_family(n):
    p=next_prime(n-1)
    normalization=2*sqrt(p.n())
    legendre_symbols=[legendre_symbol(a,p) for a in range(p)]
    legendre_family=[]
    for a in range(2,p):
        sum_legendre=sum(legendre_symbols[(t*(t-1)*(t-a))%p] for t in range(2,p))
        legendre_family.append(sum_legendre/normalization)
    return legendre_family
︡f265eace-003e-4d0e-bd96-557fe0030d98︡︡
︠594069aa-5d2e-491b-a3b6-fb52a4256db7︠
# plots the number of points of the Legendre family y^2=x(x-1)(x-t) over Fp
def plot_vert_legendre_family(n):
    v=vert_legendre_family(n)
    return sum(point((x,sum([ZZ(j<x) for j in v])/len(v))) for x in srange(-1,1,0.01))
︡66547509-769b-456b-a3fb-b4d8ecba6011︡︡
︠5044325e-09b7-41cc-9496-6d6e61e3f5bb︠
def vert_kloosterman(n):
    p=next_prime(n-1)
    k=GF(p)
    normalization=2*sqrt(p.n())
    zeta_p=exp(2*pi*I/p).n()
    zeta_powers=[zeta_p^i for i in range(p)]
    inverses=[inverse_mod(a,p) for a in range(1,p)]
    kloosterman=[]
    for a in range(1,p):
        sum_kloosterman=sum(zeta_powers[k(t)+k(a)*inverses[t-1]] for t in range(1,p))
        kloosterman.append(sum_kloosterman/normalization)
    return kloosterman
︡d2b341c8-e8d2-4a9e-b49d-264487bbd345︡︡
︠7f15980e-aab5-411f-af9b-70a36e8187a9︠
# plots the number of points of the family of two-variable Kloosterman sums over Fp
def plot_vert_kloosterman(n):
    v=vert_kloosterman(n)
    return sum(point((x,sum([ZZ(j<x) for j in v])/len(v))) for x in srange(-1,1,0.01))
︡e087783f-0389-4600-abd2-360216b47f69︡︡
︠b3b9dae1-a8bf-440d-bd48-19e40a635d9e︠
def horiz_kloosterman(n):
    list_of_primes=primes_first_n(n)
    kloosterman=[]
    for p in list_of_primes:
           normalization=2*sqrt(p.n())
           sum_kloosterman=sum(exp(2*pi*I*(t+inverse_mod(t,p))/p).n() for t in range(1,p))
           kloosterman.append(sum_kloosterman/normalization)
    return kloosterman
︡f67b3e54-85bf-4d6a-8da6-28d24984af04︡︡
︠afb44aca-d770-469a-bd33-03baaf87ba84︠
# plots the horizontal family of two-variable Kloosterman sums up to the nth prime
def plot_horiz_kloosterman(n):
    v=horiz_kloosterman(n)
    return sum(point((x,sum([ZZ(j<x) for j in v])/len(v))) for x in srange(-1,1,0.01))
︡71083700-21c4-41b0-9154-54bf3c6c4d89︡︡
︠47f9a15e-e936-42d3-a1bd-ba01b226a6d0︠
def sato_tate():
    ST=plot((1/2*sqrt(-x^2 + 4)*x + 2*arcsin(1/2*x))/(2*pi)+0.5,x,-2,2)
    return ST
︡a6b15145-76fe-4f76-8469-134b16536237︡︡
︠3662d425-34dc-4775-9466-58e6755d1295︠
plot_gauss_sums(5)
︡4c30f977-6e93-4eae-897f-d7da7d0dccba︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠14d8c85a-84cd-4f7d-99dd-715022b6d1d8︠
plot_gauss_sums(10)
︡3ce98974-45ed-4f21-8ffd-a8853f200274︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠25f5a440-e298-4e7c-a2e8-b04b974974de︠
plot_gauss_sums(50)
︡87d2f4bc-dfc3-4ce5-b227-5482d731ba8c︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠16352e99-5654-473c-be32-82f42c9b7f29︠
plot_gauss_sums(100)
︡684fb074-ba65-4646-a423-bf3819d3453d︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠4b648cd4-27c6-4b0d-89b7-f4f2bd384fa1︠
plot_gauss_sums(500)
︡14e58b83-8483-4c14-bc7d-d133576cf38a︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠0a1cd798-c38f-4985-a733-9e0e68f48dc8︠
plot_gauss_sums(1000)
︡b982470d-8e1c-4f85-a59b-8ef8600b086e︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠b406f071-a666-41e1-8ba1-b0a3c2101640︠
sato_tate()
︡62162258-e2e9-4c81-85a1-394908d005db︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠a378ca93-5be7-40d4-920c-c48c0d6ecae0︠
plot_vert_kloosterman(10)
︡15951bfc-f47b-485e-809e-02cf254dbc53︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠542cef5d-c0d6-4e0e-b1b2-03fe932f2923︠
plot_vert_kloosterman(50)
︡4425ad63-b036-4b98-a134-1196aaf8c882︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠b9767b9d-deaf-4288-a7e0-ef0dcbc0716e︠
plot_vert_kloosterman(100)
︡3393e39c-a304-4d76-b868-e710060e5bf4︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠2d60b137-4baf-45d3-af97-134fecc509e1︠
plot_vert_kloosterman(500)
︡2f80a85d-3b4c-4e3d-a195-688a0a71daf1︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠b0bb4ad5-583b-4aa7-a4fd-c9eb868ba865︠
plot_vert_kloosterman(1000)
︡d9733025-b9a7-4692-a243-11702932bdb5︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠6e89dceb-7dbf-4a2f-a6b0-1119d44dbb66︠
plot_horiz_kloosterman(10)
︡fcdff264-0138-4999-86f8-8f6f7f466649︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠8667095a-89e1-4c61-9972-c41824ab677f︠
plot_vert_kloosterman(50)
︡cf0b5015-1cab-43bb-b6ad-8d329ae4da08︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠e67d3bef-90b0-470d-9cfe-98bd70e1f42a︠
plot_vert_kloosterman(100)
︡9ac8fb27-264c-4d1c-9369-32819f5fbf1a︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠31a6164d-278a-4168-b067-1fab39e48702︠
plot_vert_kloosterman(500)
︡95b5f786-9d23-4116-8ad4-65f1f6b35796︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠143840ed-f328-4c36-a65f-afeb7e2a772b︠
plot_vert_kloosterman(1000)
︡294eddb0-98fa-4a91-8d7d-4ec0d9d377d0︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
